<?php

session_start();
require_once('phpmytop_libs.php');

if (!isset($_SESSION['refresh'])) {
    $_SESSION['refresh'] = 5;
}

if (isset($_REQUEST['refresh'])) {
    $_SESSION['refresh'] = $_REQUEST['refresh'];
}

if (!isset($_SESSION['idle'])) {
    $_SESSION['idle'] = false;
}

if (isset($_REQUEST['idle'])) {
    $_SESSION['idle'] = $_REQUEST['idle'];
}

// Reset QPS if user requests it
if (isset($_REQUEST['reset_qps'])) {
    $_SESSION['mytop_begin'] = time();
    $_SESSION['mytop_begin_queries'] = MyStats::getTotalQueries($GLOBALS['dbconn'][0]);
}

// Track Queries/Second
if (!isset($_SESSION['mytop_begin'])) {
    $_SESSION['mytop_begin'] = time();
}

if (!isset($_SESSION['mytop_begin_queries'])) {
    $_SESSION['mytop_begin_queries'] = MyStats::getTotalQueries($GLOBALS['dbconn'][0]);
}

?>
<html>
<head>
<?php
print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"{$_SESSION['refresh']}\">\n";
?>
<title>phpMyTop - MySQL DB Monitor</title>
<link rel="STYLESHEET" type="text/css" href="css/phpMyTop.css">
</head>
<!-- <body bgcolor="#0000a3"> -->
<body>
<center>
<table class=maintable width=850>
<tr>
 <td valign=bottom width=337><img src=images/phpMyTop_cooltext8.png><!-- <h1>php<font class=my>My</font><font class=top>Top</font></h1> --></td>
 <td align=right valign=top>
<?php

print "<form method=post action=index.php><font class=greyserif9>Refresh:</font> <input class=form type=text size=3 name=refresh value={$_SESSION['refresh']}><input class=form type=submit value=Go></td>\n";
print "<td align=right>\n";

$qps_total = round(MyStats::getTotalQueries($GLOBALS['dbconn'][0]) / MyStats::getServerUptimeSeconds($GLOBALS['dbconn'][0]), 2);
$qps_mytop = round((MyStats::getTotalQueries($GLOBALS['dbconn'][0]) - $_SESSION['mytop_begin_queries'] + 1) / (time() - $_SESSION['mytop_begin'] + 1), 2);
$qps_now = round((MyStats::getTotalQueries($GLOBALS['dbconn'][0]) - $_SESSION['mytop_last_queries'] + 1) / (time() - $_SESSION['mytop_last'] + 1), 2);

$_SESSION['mytop_last'] = time();
$_SESSION['mytop_last_queries'] = MyStats::getTotalQueries($GLOBALS['dbconn'][0]);
print "<table>\n";
print "<tr><td>Threads</td></tr>\n";
print "<tr><td>Total:</td><td><b>".MyStats::getThreadsTotal($GLOBALS['dbconn'][0])."</b></td></tr>\n";
print "<tr><td>Active:</td><td><b>".MyStats::getThreadsActive($GLOBALS['dbconn'][0])."</b></td></tr>\n";
print "<tr><td>Idle:</td><td><b>".MyStats::getThreadsIdle($GLOBALS['dbconn'][0])."</b></td></tr>\n";
print "<tr><td>DB Host:</td><td><b>".$GLOBALS['dbhost'][0]."</b></td></tr>\n";
print "</table>\n";
print "</td>\n";
print "<td align=right>\n";
print "<table>\n";
print "<tr><td colspan=2>Query Ratios</td></tr>\n";
print "<tr><td>SELECT:</td><td><b>".round(MyStats::getNumSelects($GLOBALS['dbconn'][0]) / MyStats::getTotalQueries($GLOBALS['dbconn'][0]) * 100, 2)."%</b></td></tr>\n";
print "<tr><td>INSERT:</td><td><b>".round(MyStats::getNumInserts($GLOBALS['dbconn'][0]) / MyStats::getTotalQueries($GLOBALS['dbconn'][0]) * 100, 2)."%</b></td></tr>\n";
print "<tr><td>UPDATE:</td><td><b>".round(MyStats::getNumUpdates($GLOBALS['dbconn'][0]) / MyStats::getTotalQueries($GLOBALS['dbconn'][0]) * 100, 2)."%</b></td></tr>\n";
print "<tr><td>DELETE:</td><td><b>".round(MyStats::getNumDeletes($GLOBALS['dbconn'][0]) / MyStats::getTotalQueries($GLOBALS['dbconn'][0]) * 100, 2)."%</b></td></tr>\n";
print "</table>\n";
print "</td><td align=right>\n";
print "<table>\n";
print "<tr><td>Server Version:</td><td><b>".MyStats::getServerVersion($GLOBALS['dbconn'][0])."</b></td></tr>\n";
//print "<tr><td>Current Database:</td><td><b>".$GLOBALS['db'][0]."</b></td></tr>\n";
print "<tr><td>Server Uptime:</td><td><b>".MyStats::getServerUptime($GLOBALS['dbconn'][0])."</b></td></tr>\n";
print "<tr><td>QPS Total:</td><td><b>".$qps_total."</b></td></tr>\n";
print "<tr><td>QPS This Session:</td><td><b>".$qps_mytop."</b> &nbsp;<a href=index.php?reset_qps=true>Reset</a></td></tr>\n";
print "<tr><td>QPS Now:</td><td><b>".$qps_now."</b></td></tr>\n";
print "</table>\n";
print " </td>\n";
print "</tr>\n";
print "</table>\n";
print "<table width=850>\n";
print "<tr valign=center>\n";
print "<td>Index Usage: <b>".MyStats::getIndexHitRate($GLOBALS['dbconn'][0])."%</b></td>";
print "<td>Query Cache Hit Rate: <b>".MyStats::getQueryCacheHitRate($GLOBALS['dbconn'][0])."%</b></td>\n";
print "<td>Slow Queries: <b>".MyStats::getSlowQueries($GLOBALS['dbconn'][0])."</b></td>\n";
print "<td>Table Scans: <b>".MyStats::getTableScans($GLOBALS['dbconn'][0])."</b></td>\n";
print "<td>Table Locks Waited: <b>".MyStats::getTableLocksWaited($GLOBALS['dbconn'][0])."%</b></td>\n";
#print "<td><form method=post action=index.php>Refresh: <input class=form type=text size=3 name=refresh value={$_SESSION['refresh']}><input class=form type=submit value=Go></td>\n";
print "<td>Show Idle: <b>";
if ($_SESSION['idle']) {
    print "Yes </b>/<b> <a href=index.php?idle=0>No</a></b></td>\n";
} else {
    print "<a href=index.php?idle=1>Yes</a> </b>/<b> No</b></td>\n";
}
print "</tr>\n";
print "</table>\n";

if ($_SESSION['idle']) {
    $pslist = MyStats::listProcesses($GLOBALS['dbconn'][0]);
} else {
    $pslist = MyStats::listProcessesNoIdle($GLOBALS['dbconn'][0]);
}

print "<table border=0 cellspacing=0 width=850>\n";
print "<tr class=tableheader><td><b>ID</b></td><td><b>Host</b></td><td><b>User</b></td><td><b>Time</b></td><td><b>State</b></td><td><b>DB</b></td><td width=500><b>Query</b></td></tr>\n";
$rowcount = 0;
foreach ($pslist as $ps) {
    print "<tr><td class=serif9>{$ps['Id']}</td>\n";
    print "<td class=serif9>{$ps['Host']}</td>\n";
    print "<td class=serif9>{$ps['User']}</td>\n";
    print "<td class=serif9>{$ps['Time']}</td>\n";
    if ($ps['Command'] == 'Sleep' or $ps['Command'] == 'SHOW FULL PROCESSLIST') {
    	print "<td class=serif9>{$ps['Command']}</td>\n";
    } else {
        print "<td class=serif9>{$ps['Command']}</td>\n";
        MyStats::addQueryHistory($GLOBALS['mytop_dbconn'], $ps['db'], $ps['Info']);
    }
    print "<td class=serif9>{$ps['db']}</td>\n";
    if (strlen($ps['Info']) > 100) {
        $ps['Info'] = substr($ps['Info'], 0, 100)." . . . ";
    }
    if ($ps['Info'] != '' and $MarkIsGod == true) { // Linking temporarily disabled ;)
        print "<td class=serif9><a href=query.php>{$ps['Info']}</a></td>\n";
    } else {
        print "<td class=serif9>{$ps['Info']}</td></tr>\n";
    }
    $rowcount++;
}
// Make sure we fill the screen
for ($a = $rowcount; $a < 80; $a++) {
    print "<tr><td colspan=6></td></tr>\n";
}
print "</table>\n";

?>
Copyright 2005 &nbsp;-|||-&nbsp; Created By: Mark Cotner &nbsp;-|||-&nbsp; 'njoy
</center>
</body>
</html>
